package com.gic.haoban.manage.service.task;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSON;
import com.gic.haoban.manage.api.dto.DealParamMqDTO;
import com.gic.haoban.manage.api.dto.ExternalUserDTO;
import com.gic.haoban.manage.api.enums.PreDealStatusEnum;
import com.gic.haoban.manage.api.service.MemberUnionidRelatedApiService;
import com.gic.haoban.manage.service.entity.TabHaobanPreDealLog;
import com.gic.haoban.manage.service.service.PreDealService;

@Service
public class FriendMergeSyncOperation implements BaseSyncOperation{

	@Autowired
	private MemberUnionidRelatedApiService memberUnionidRelatedApiService;
	@Autowired
	private PreDealService preDealService;
	@Override
	public void dealSingleByMq(DealParamMqDTO dealParamMqDTO, TabHaobanPreDealLog dataPre) {
		String dataContent = dataPre.getDataContent();
		ExternalUserDTO pojo = JSON.parseObject(dataContent, ExternalUserDTO.class);
		String res = memberUnionidRelatedApiService.addExternal(pojo);
		if(StringUtils.isBlank(res)){
			dealSuccess(dealParamMqDTO.getTaskId(), dataPre.getDataId(), null, null);
		}else{
			dealException(dealParamMqDTO.getTaskId(), dataPre.getDataId(), null, res);
		}
		
	}

	@Override
	public void dealException(String taskId, String dataId, String enterpriseId, String reason) {
		preDealService.updateStatusByDataId(taskId, dataId, PreDealStatusEnum.exception.getVal(), reason);
		
	}

	@Override
	public void dealSuccess(String taskId, String dataId, String enterpriseId, String wxEnterpriseId) {
		preDealService.updateStatusByDataId(taskId, dataId, PreDealStatusEnum.computed.getVal(), "成功");
		
	}

	@Override
	public void checkDepartmentTask(String taskId) {
		
	}

}
